gui/config/routes.rb
Smr::Application.routes.draw do

  root :to => 'asset#index'

  resources :asset
  get  '/asset/show_portfolio/:id_portfolio', :to=>'asset#index', :as=>'show_portfolio'
  post '/asset/show_portfolio/',              :to=>'asset#index', :as=>'show_portfolio_post'

  resources :order
  resources :report
  resources :cashflow
  resources :watchlist
  resources :figures
  resources :quoterecords
  resources :quoterecord_threshold
  resources :quoterecord_rules

  post "set_session_params" => "application#set_session_params"

  get 'logout' => 'sessions#destroy', :as => 'logout'
  get 'login' => 'sessions#new', :as => 'login'
  resources :sessions
  resources :password_reset

  resources :position
  post 'execute_order', to: 'position#execute_order'
  post 'cancel_order', to: 'position#cancel_order'
  post 'patch_position', to: 'position#patch'
  get 'close', to: 'position#close'

  get '/workdesk/add',      :to=>'workdesk#add',  :as=>'workdesk_add'
  get '/workdesk/:id/drop', :to=>'workdesk#drop', :as=>'workdesk_drop'
  resources :workdesk

  resources :portrait
  get '/portrait/organization/:id', :to=>'portrait#show_organization', :as=>'portrait_organization'
  get '/portrait/security/:id',     :to=>'portrait#show_security',     :as=>'portrait_security'

  resources :cashposition
  get '/cashposition/:id/settle', :to=>'cashposition#settle', :as=>'settle_cashposition'

  resources :documents
  get 'download' => 'documents#download'
  get 'delete_document' => 'documents#delete_document'

  resources :blog
  get 'blog' => 'blog#index'

  get 'objects' => 'objects#index'
  namespace 'objects' do
      resources :organization, :security, :bookmark, :portfolio, :figurevar, :user
      post 'patch_portfolio', to: 'portfolio#patch'
  end
  get '/objects/security/:id/delete', :to=>'objects/security#destroy', :as=>'delete_security'
  get '/objects/export/securities',   :to=>'objects/security#export',  :as=>'export_securities'
  get '/objects/bookmark/:id/delete', :to=>'objects/bookmark#destroy', :as=>'delete_bookmark'

  resources :doc, :only=>:get_file
  get "/doc/:file_or_folder", :controller=>:documentation, :action=>:get_file, :file_or_folder=>/.*/
end

gui/app/controllers/objects/bookmark_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# handles CRUD on Bookmark records
class Objects::BookmarkController < ObjectsController

    ##
    # List all Bookmark records for editing.
    def index
        super
        session[:objects_bookmark_query] = params[:q] if params[:q]

        @query = Bookmark.ransack(session[:objects_bookmark_query])
        @bookmarks, @total_pages = smr_paginate(
            @page=smr_page,
            @query.result.to_a
        )
    end

    ##
    # defines empty Bookmark to #create a new one
    def new
        @securities = smr_securities_list
        @organizations = smr_organizations_list(:drop_universe=>false)
        @portfolios = smr_portfolios_list(:show_all=>true)
        @figure_vars = FigureVar.for_user(current_user.id)

        @bookmark = Bookmark.new(:id_user=>current_user.id)
    end

    ##
    # retrieve Bookmark for editing
    def edit
        self.new
        @bookmark = Bookmark.for_user(current_user).where(:id=>params[:id]).first
        render :new
    end

    ##
    # handles creates and updates
    def create
        n = Array.new

        if params[:bookmark][:id].to_i > 0 then
            bookmark = Bookmark.for_user(current_user).where(:id=>params[:bookmark][:id]).first
            bookmark.update(bookmark_params)
        else bookmark = Bookmark.create(bookmark_params.merge({:id_user=>current_user.id})) end

        bookmark.id_user = params[:mark_bookmark_private] == '1' ? current_user.id : 0
        bookmark.save
        n << bookmark.errors.full_messages.uniq

        redirect_to objects_bookmark_index_path, :notice=>n.compact.flatten.join(', ')
    end

    ##
    # delete Bookmark
    def destroy
        b = Bookmark.find(params[:id])
        begin b.destroy
        rescue ActiveRecord::DeleteRestrictionError => errors
            flash[:alert] = errors.to_s
        end

        redirect_to :action=>:index
    end

 protected

    ##
    # internal helper defining parameters acceptable for Bookmark create/update
    def bookmark_params
        params.require(:bookmark).permit(
          :name, :url, :rank,
          :id_security, :id_organization, :id_portfolio, :id_figure_var
        )
    end

end

gui/app/controllers/objects/figurevar_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# handles CRUD on FigureVar records
class Objects::FigurevarController < ObjectsController
    def index
        super
        @figurevars, @total_pages = smr_paginate(
            @page = smr_page,
            FigureVar.where(:id_user=>[0,current_user.id]).order(:name).to_a
        )
    end

    ##
    # defines empty FigureVar to create() a new one
    def new
        @figurevar = FigureVar.new
    end

    ##
    # edit existing FigureVar
    def edit
        @figurevar = FigureVar.where(:id=>params[:id]).for_user(current_user.id).first
        render :new
    end

    ##
    # handles creates and updates
    def create
        if params[:figure_var][:id].to_i > 0 then
            fv = FigureVar.where(:id=>params[:figure_var][:id]).for_user(current_user.id).first
        else fv = FigureVar.new(figurevar_params) end

        # hard-wired so noone spoofes it in here
        # FIXME: how to handle properly? given 0 _or_ current user id
#        fv.id_user = current_user.id

        if params[:figure_var][:id].to_i > 0 then
            fv.update(figurevar_params)
        else fv.save end

        redirect_to objects_figurevar_index_path, :notice=>fv.errors.full_messages.uniq.join(', ')
    end

 protected

    ##
    # internal helper defining parameters acceptable for FigureVar create/update
    def figurevar_params
        params.require(:figure_var).permit(
          :name, :unit, :expression, :comment,
          :Bookmark_attributes=> [ :id, :name, :url, :rank ]
        )
    end
end

gui/app/controllers/objects/organization_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# handles CRUD on Organization records
class Objects::OrganizationController < ObjectsController
    def index
        super
        session[:objects_organization_query] = params[:q] if params[:q]

        @query = Organization.ransack(session[:objects_organization_query])
        @organizations, @total_pages = smr_paginate(
            @page = smr_page,
            @query.result.to_a
        )
    end

    ##
    # defines empty Organization to create() a new one
    def new
        @organization = Organization.new
        render :edit
    end

    ##
    # edit existing Organization
    def edit
        @organization = Organization.where(:id=>params[:id]).first
    end

    ##
    # handles creates and updates
    def create
        if params[:organization] and params[:organization][:id].to_i > 0 then
            o = Organization.where(:id=>params[:organization][:id]).first
        else o = Organization.new(organization_params) end

        # hard-wired so noone spoofes it in here
        # FIXME: how to handle properly? given 0 _or_ current user id
#        fv.id_user = current_user.id

        if params[:organization][:id].to_i > 0 then
            o.update(organization_params)
        else o.save end

        redirect_to objects_organization_index_path, :notice=>o.errors.full_messages.uniq.join(', ')
    end

 protected

    ##
    # internal helper defining parameters acceptable for Organization create/update
    def organization_params
        params.require(:organization).permit(
          :id, :name, :contact_email, :description,
          :Bookmark_attributes=> [ :id, :name, :url, :rank ]
        )
    end
end

gui/app/controllers/objects/portfolio_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# handles CRUD on Portfolio records
class Objects::PortfolioController < ObjectsController
    def index
        super
        @portfolios, @total_pages = smr_paginate(@page = smr_page, smr_portfolios_list(:show_all=>true))
    end

    ##
    # defines empty Portfolio to create() a new one
    def new
        @portfolio = Portfolio.new(:date_created=>Time.now.to_i)
    end

    ##
    # edit Portfolio
    def edit
        @portfolio = Portfolio.find(params[:id])

        @portfolios = smr_portfolios_list(:show_all=>true)
        @assets = Smr::Asset.new(current_user.id, smr_browse_date,
            :id_portfolio=>@portfolio.id, :skip_cash_positions=>true)
        @open_positions = @assets.open_positions
        render :new
    end

    ##
    # handles creates and updates
    def create
        if params[:portfolio][:id].to_i > 0 then
            p = Portfolio.where(:id=>params[:portfolio][:id], :id_user=>current_user.id).first
        else p = Portfolio.new(portfolio_params) end

        # hard-wired so noone spoofes it in here
        p.id_user = current_user.id
        p.date_created = Time.parse(params[:time_created]).to_i if params[:time_created]

        # FIXME: not used any longer but required by schema, drop it?
        p.type = ''
        if params[:portfolio][:id].to_i > 0 then
            p.update(portfolio_params)
        else p.save end

        redirect_to objects_portfolio_index_path, :notice=>p.errors.full_messages.uniq.join(', ')
    end

    ##
    # handles Position transfers to another Portfolio
    def patch
        n = Array.new
        a = Array.new

        if params[:id_portfolio_transfer] and not params[:positions].empty? then
            Position.where(:id=>params[:positions])
                .joins(:Portfolio).where(:portfolio=>{:id_user=>current_user.id}).each do |p|
                p.id_portfolio = params[:id_portfolio_transfer]
                p.save || a << 'transfering position #%i failed' % p.id
            end
            n << 'Positions have been transfered sucessfully.'
        else
            a << 'Please specify a portfolio as transfer destination and select at lease one position.'
        end

        redirect_to objects_portfolio_index_path, :notice=>n.join(','), :alert=>a.join(',')
    end

 protected

    ##
    # internal helper defining parameters acceptable for Portfolio create/update
    def portfolio_params
        params.require(:portfolio).permit(
          :id, :name, :date_created, :taxallowance, :order, :comment,
          :Bookmark_attributes=> [ :id, :name, :url, :rank ]
        )
    end
end

gui/app/controllers/objects/user_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# handles CRUD on User records
class Objects::UserController < ObjectsController
    def index
        super
        @users, @total_pages = smr_paginate(
            @page = smr_page,
            User.order(:login).to_a
        )
    end

    ##
    # defines new User to #create
    def new
        @user = User.new
    end

    ##
    # edit User
    # - until proper permissions are implemented a User can only edit itself,
    #   but not others
    # - each User can, however, create new users.
    def edit
        @user = current_user
        render :new
    end

    ##
    # handles creates and updates
    # - until proper permissions are implemented a User can only edit itself,
    #   but not others
    def create
        if params[:user][:id].to_i > 0 then
            u = User.where(:id=>current_user.id).first
            u.update(user_params)

            if not params[:user][:password].empty? then
                if params[:user][:password].eql?(params[:user][:password_confirm]) then
                    u.password = params[:user][:password].to_s
                    u.save
                    flash[:notice] = 'Password changed.'
                else
                    redirect_to :back, :alert=>'Confirming password failed. Typo?'
                    return
                end
            end
        else
            u = User.new(user_params)
            flash[:notice] = 'new users initial password is: "%s"' % u.generate_password
            u.save
        end

        flash[:alert] = u.errors.full_messages.uniq.join(', ') unless u.errors.empty?
        redirect_to objects_user_index_path
    end

 protected

    ##
    # internal helper defining parameters acceptable for User create/update
    def user_params
        params.require(:user).permit(
            :id, :login, :is_admin, :fullname, :email, :comment,
            :Bookmark_attributes=> [ :id, :name, :url, :rank ]
        )
    end

end

gui/app/controllers/objects_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# CRUD objects such as Portfolio, Security, FigureVar, SecurityQuotesource,
# SecuritySymbolextension, ...
class ObjectsController < ApplicationController
    ##
    # builds the menu for all objects namespaced below
    def index
        @headline='Objects'
        smr_menu_addsubitem('objects', {
            'securities'=>:objects_security_index,
            '+ security'=>:new_objects_security,
            'organizations'=>:objects_organization_index,
            '+ organization'=>:new_objects_organization,
            'bookmarks'=>:objects_bookmark_index,
            '+ bookmark'=>:new_objects_bookmark,
            'portfolios'=>:objects_portfolio_index,
            '+ portfolio'=>:new_objects_portfolio,
            'figures'=>:objects_figurevar_index,
            '+ figure'=>:new_objects_figurevar,
            'users'=>:objects_user_index,
            '+ user'=>:new_objects_user,
        })
    end
end

gui/app/views/objects/bookmark/_nested_form.html.erb
<%
##
# This partial creates nested fields in the context of a form (#form_for). It
# can not be used standalone.
#
# Provide these locals:
#
# :form => ActionView::Helpers::FormBuilder
#          - thats the object you are running over with #form_for
#          - its #object must be an instance of Organization, Security,
#            Portfolio or FigureVar
#
# :user => User
#          - make sure that user has authenticated!
#
accepts = [ Organization, Security, Portfolio, FigureVar, User ]
unless accepts.include? form.object.class
    raise ':form.object should be one of %s' % accepts.join(' ')
end

%>
<fieldset id='bookmarks'>
 <legend>Bookmarks</legend>
    <%= form.fields_for :Bookmark, form.object.bookmarks_for_form(user) do |br| %>
        <%= br.text_field :name, :min=>3, :value=>br.object.name, :placeholder=>'Name' %>
        <%= br.url_field  :url, :value=>br.object.url, :placeholder=>'URL' %>
        <%= br.select :rank, options_for_select(Bookmark.ranks_for_form, :prompt=>'-- Specify Rank --', :selected=>br.object.rank) %>
        <br/>
    <% end %>
</fieldset>

gui/app/views/objects/bookmark/index.html.erb
<h1><%= @headline %></h1>


<h2>Bookmarks</h2>
<% if not @bookmarks %>
    <p>No books marked yet.</p>
<% else %>

<%= search_form_for @query, :url=>{:action=>:index}, :class=>:filter_form, :id=>:controller_filter do |f| %>
<div>
  <%= f.search_field :name_or_url_cont_any, :placeholder=>'Pattern' %>
  <%= f.submit :filter %>

  <table>
     <tr><th colspan="2">Quality</th></tr>
     <% Bookmark.ranks_for_form(:as_number=>true).each do |r|
            checked = if params[:q] and params[:q].key?(:rank_eq_any) and params[:q][:rank_eq_any].first.to_i == r.second
                        true
                    else false end
     %>
        <tr>
            <td><%= check_box_tag 'q[rank_eq_any][]', r.second, checked %></td>
            <td><%= label_tag 'q[rank_eq_any][]', r.first %></td></tr>
     <% end %>
  </table>
</div>
<% end %>


<table id='bookmarks'>
    <thead>
    <tr>
        <th><%= smr_paginate @page, @total_pages, objects_bookmark_index_path %></th>
        <th>Added</th>
        <th>Related To</th>
        <th>Actions</th>
    </tr>
    </thead>
    <tbody>
    <% @bookmarks.each do |b| %>
        <tr class="separaterows">
            <td>
              <%= link_to '+', edit_objects_bookmark_path(b.id) %>
              <%= b %><br/>
              <%= link_to truncate(b.url, :length=>40), b.url if b.url %>
            </td>
            <td><%= smr_humanize b.time_added, :time_for_humans=>true %></td>
            <td>
                <%= b.relations.map { |o| link_to o, o.link.to_url}.join(', ').html_safe %>
            </td>
            <td><%= link_to 'delete', delete_bookmark_path(:id=>b.id) %></td>
        </tr>
    <% end %>
    </tbody>
</table>
<% end %>

gui/app/views/objects/bookmark/new.html.erb
<%= form_for @bookmark, :url=>{:action=>:create}, :method=>:POST do |f| %>
 <fieldset id='bookmark'>
  <legend><% if @bookmark.id %>Edit<% else %>Add<% end %> Bookmark</legend>
    <%= f.submit 'Save' %><br/>
    <%= f.hidden_field :id %>

    <%= f.text_field :name, :size=>25, :placeholder=>'Name' %>
    <%= f.url_field :url, :size=>25, :placeholder=>'URL' %>
    <%= f.select :rank, options_for_select(Bookmark.ranks_for_form, :selected=>f.object.rank), :prompt=>'-- Select Rank --' %><br/>

    Link to:
    <ul>
      <li><%= check_box_tag :mark_bookmark_private, 1, (f.object.id_user > 0) %><%= f.label :mark_bookmark_private, 'Me' %> <span>only I can see this bookmark</span></li>
      <li><%= f.select :id_security,     options_from_collection_for_select(@securities, :id, :to_s_with_symbol, f.object.id_security), :include_blank=>'-- Link Security --' %></li>
      <li><%= f.select :id_organization, options_from_collection_for_select(@organizations, :id, :to_s, f.object.id_organization), :include_blank=>'-- Link Organization --' %></li>
      <li><%= f.select :id_portfolio,  options_from_collection_for_select(@portfolios, :id, :to_s, f.object.id_portfolio), :include_blank=>'-- Link Portfolio --' %></li>
      <li><%= f.select :id_figure_var, options_from_collection_for_select(@figure_vars, :id, :to_s, f.object.id_figure_var), :include_blank=>'-- Link Figure --' %></li>
    </ul>

 </fieldset>
<% end %>